﻿; -------------------------------------------
;
;		Jadis, clone de "Jade" sur Amstrad CPC
;		Reprogrammé par Retro-Bruno en Purebasic
;		http://www.retro-bruno.com
;
; -------------------------------------------

IncludeFile "Player.pbi"

Declare initVars()
Declare drawPage()
Declare testClicks(mx,my)
Declare.s noForbidenChar(c$)
Declare findNextSelVerb()
Declare findBackSelVerb()
Declare findNextVerb()
Declare findBackVerb()
Declare saveJad(nom$,rep$)
Declare clearZoneClick()
Declare.s zeros(n)
Declare multiLineText(t$,x,y,w,h,margex,margey,r,g,b,draw = #True)
Declare centerText(t$,x,y,r,g,b)
Declare findVerb(v1)
Declare bicolorText(t$,x,y)
Declare bicolorTextLinks(t$,x,y,n1,n2,n3)
Declare TestMouse()

; INTRO --------------------------------------------------

If InitScreen() = #False
  error("Impossible d'utiliser le mode graphique 800x600 pixels en 32 bits !")
EndIf
SetWindowTitle(0, "Jadis (clone de 'Jade' sur Amstrad CPC)")
If LoadFonts() = #False
  error("Impossible de charger la police de caracteres !")
EndIf
If loadDefault() = #False
  error("Probleme d'initialisation !")
EndIf

intro = LoadImage(#PB_Any, "Images" + SL + "introduction.jpg")
Global deco1 = LoadImage(#PB_Any, "Images" + SL + "deco1.png")
Global deco2 = LoadImage(#PB_Any, "Images" + SL + "deco2.png")
Global deco3 = LoadImage(#PB_Any, "Images" + SL + "deco3.png")
Global nseo = LoadImage(#PB_Any, "Images" + SL + "nseo.png")
Global suppr = LoadImage(#PB_Any, "Images" + SL + "suppr.png")
Global supprSel = LoadImage(#PB_Any, "Images" + SL + "supprSel.png")

If intro = 0 Or deco1 = 0 Or deco2 = 0 Or deco3 = 0 Or nseo = 0 Or suppr = 0 Or supprSel = 0
	error("Impossible de charger une des images du logiciel !")
EndIf

ExamineEvents()
While LeftClick = #False And KeyEscape = #False And KeyReturn = #False
  StartDrawing(ImageOutput(0))
  DrawImage(ImageID(intro),0,0)
  StopDrawing()
  StartDrawing(CanvasOutput(1))
  DrawImage(ImageID(0), 0, 0)
  StopDrawing()
  ExamineEvents()
  Delay(1)
Wend

Global circonflexe = #False ; Gestion de l'accent circonflexe
Global trema = #False ; Gestion du tréma

Global minZC2 = 40 ; Numéro minimum de zone clickable supérieur
Global longZC2 = 3 * 25 ; Nombre de zones clickables supérieures
Global maxZC = minZC2 + longZC2 ; Nombre maximum de zone clickables (au total)
Global Dim zoneClick.i(maxZC,5) ; numéro,x,y,w,h
obj = 0 ; objet cliqué (-1 = Echap)

Global verbx = 0
Global verby = 0
Global verbselx = 0
Global verbsely = 0
Global POSMIDDLE = 0
Global POSTOP = 1
Global POSBOTTOM = 2
Global verbpos = POSTOP

Global kb = #False ; saisie clavier, désactive la souris
Global v$ = "" ; Verbe, saisie en cours
Global KBEDIT = 1
Global KBINST = 2
Global kbType = KBEDIT

Global PrinSel ; Sélection d'un nombre à paramétrer dans le menu principal

Global cn = #False ; choisir un nombre de 0 à 255
Global monNombre1 = 0 ; nombre à choisir
Global monNombre2 = 0 ; deuxième nombre à choisir

Global numeroMessage ; Numéro du message visible dans la section Texte Messages
Global numeroSalle ; Numéro du salle visible dans la section Texte Salles

Global dirSel ; Direction sélectionnée pour action avec la molette ou les flêches
Global numeroSalleDir ; Numéro du salle dans la section Déplacements

Global numeroObjet ; Numéro de l'objet visible dans la section Texte Objets

Global ObjLieuSel ; Objet ou Salle sélectionnée pour modification
Global numeroObjetLieu ; Numéro d'objet auquel attribuer un numéro de Salle

Global EMinSel ; Sélection de l'objet courant actif à la molette dans les événements mineurs
Global EM_CONDITIONS = 1
Global EM_ACTIONS = 2
Global EMinCondAct ; Swapper l'affichage entre le menu CONDITIONS et ACTIONS

Global EMajSel ; Sélection de l'objet courant actif à la molette dans les événements majeurs
Global EMajCondAct ; Swapper l'affichage entre le menu CONDITIONS et ACTIONS

Global gi ; Global indice

Global numCondAct ; Numéro de liste de conditions et d'actions (de 0 à 999)
Global zoneCond ; Zone de condition sélectionnée
Global zoneAct ; Zone d'action sélectionnée
; Indices associés à la zone de condition et d'action
Global indC1
Global indC2
Global indC3
Global indA1
Global indA2
Global indA3
Global supprCond
Global supprAct

Global numCondActMaj ; Numéro de liste de conditions et d'actions (de 0 à 999)
Global zoneCondMaj ; Zone de condition sélectionnée
Global zoneActMaj ; Zone d'action sélectionnée
; Indices associés à la zone de condition et d'action
Global indC1Maj
Global indC2Maj
Global indC3Maj
Global indA1Maj
Global indA2Maj
Global indA3Maj
Global supprCondMaj
Global supprActMaj

Global numeroMsgSys ; Numéro de message système en cours

Global baseDir ; Position dans tenDirs
Global dirCount ; Nombre d'items dans tenDirs

Global numeroAttribObjet ; Numéro d'objet auquel attribuer un mot du vocabulaire
Global attrSel ; Séléction de la zone active à la molette 

initVars()
init() ; initialisation

Global gameDir$ = ""

Global FLECHEHAUT = 1
Global FLECHEBAS = 2

Global menuPrincipal = 0
Global menuVocabulaire = 1
Global menuTexteMessages = 2
Global menuTexteSalles = 3
Global menuDeplacements = 4
Global menuTexteObjets = 5
Global menuPlacerObjets = 6
Global menuEvtsMineurs = 7
Global menuEvtsMajeurs = 8
Global menuMessageSystemes = 9
Global menuMultimedia = 10
Global menuSauverFichier = 11
Global menuChargerFichier = 12
Global menuAttribObjets = 13
Global menuTesterJeu = 14
Global menuReinitialiser = 15
Global menuQuitter = 16
Global menuType = menuPrincipal

Global MainLoop = #True ; Boucle principale

While MainLoop = #True

drawPage()
StartDrawing(CanvasOutput(1))
DrawImage(ImageID(0), 0, 0)
StopDrawing()

ExamineEvents()
  
If KeyEscape = #True
	If menuType = menuPrincipal
		MainLoop = #False
		Break
	Else
		menuType = menuPrincipal
		kb = #False
		cn = #False
		drawPage()
	EndIf
EndIf

If KeyBack = #True
	If menuType = menuEvtsMineurs
		If EMinCondAct = EM_CONDITIONS And supprCond > -1
			For i = supprCond To 23
				For j = 0 To 3
					numCond(i,j,numCondAct) = numCond(i+1,j,numCondAct)
				Next
			Next
			numCond(24,0,numCondAct) = -1
			numCond(24,1,numCondAct) = 255
			numCond(24,2,numCondAct) = 255
			numCond(24,3,numCondAct) = 255
			If numCond(0,0,numCondAct) = -1
				supprCond = -1
				EMinSel = 0
			EndIf
			drawPage()
		ElseIf EMinCondAct = EM_ACTIONS And supprAct > -1
			For i = supprAct To 23
				For j = 0 To 3
					numAct(i,j,numCondAct) = numAct(i+1,j,numCondAct)
				Next
			Next
			numAct(24,0,numCondAct) = -1
			numAct(24,1,numCondAct) = 255
			numAct(24,2,numCondAct) = 255
			numAct(24,3,numCondAct) = 255
			If numAct(0,0,numCondAct) = -1
				supprAct = -1
				EMinSel = 0
			EndIf
			drawPage()
		EndIf
	ElseIf menuType = menuEvtsMajeurs
		If EMajCondAct = EM_CONDITIONS And supprCondMaj > -1
			For i = supprCondMaj To 23
				For j = 0 To 3
					numCondMaj(i,j,numCondActMaj) = numCondMaj(i+1,j,numCondActMaj)
				Next
			Next
			numCondMaj(24,0,numCondActMaj) = -1
			numCondMaj(24,1,numCondActMaj) = 255
			numCondMaj(24,2,numCondActMaj) = 255
			numCondMaj(24,3,numCondActMaj) = 255
			If numCondMaj(0,0,numCondActMaj) = -1
				supprCondMaj = -1
				EMajSel = 0
			EndIf
			drawPage()
		ElseIf EMajCondAct = EM_ACTIONS And supprActMaj > -1
			For i = supprActMaj To 23
				For j = 0 To 3
					numActMaj(i,j,numCondActMaj) = numActMaj(i+1,j,numCondActMaj)
				Next
			Next
			numActMaj(24,0,numCondActMaj) = -1
			numActMaj(24,1,numCondActMaj) = 255
			numActMaj(24,2,numCondActMaj) = 255
			numActMaj(24,3,numCondActMaj) = 255
			If numActMaj(0,0,numCondActMaj) = -1
				supprActMaj = -1
				EMajSel = 0
			EndIf
			drawPage()
		EndIf
	EndIf
EndIf

If LeftClick = #True And Not kb And Not cn
	obj = testClicks(WindowMouseX(0),WindowMouseY(0))
	objClicked = #True
Else
	objClicked = #False
EndIf

; Gestion Molette de souris
co = 1
If KeyControl = #True
  co = 10
EndIf
; Gestion de Control+Molette et des touches Haut, Bas (+Control)
If KeyUp = #True
	roll = 1
ElseIf KeyDown = #True
  roll = -1
ElseIf KeyPageUp = #True
	roll = 1
	co = 10
ElseIf KeyPageDown = #True
	roll = -1
	co = 10
EndIf

If Not kb And Not cn
	Select menuType
		Case menuPrincipal
			If roll > 0 
				Select PrinSel
					Case 1
						zoneImage\x + co
						If zoneImage\x > 799
						  zoneImage\x - 800
						EndIf
					Case 2
						zoneImage\y + co
						If zoneImage\y > 599
						  zoneImage\y - 600
						EndIf
					Case 3
						zoneImage\w + co
						If zoneImage\w > 800
						  zoneImage\w - 800
						EndIf
					Case 4
						zoneImage\h + co
						If zoneImage\h > 600
						  zoneImage\h - 600
						EndIf
					Case 5
						zoneDescription\x + co
						If zoneDescription\x > 799
						  zoneDescription\x - 800
						EndIf
					Case 6
						zoneDescription\y + co
						If zoneDescription\y > 599
						  zoneDescription\y - 600
						EndIf
					Case 7
						zoneDescription\w + co
						If zoneDescription\w > 800
						  zoneDescription\w - 800
						EndIf
					Case 8
						zoneDescription\h + co
						If zoneDescription\h > 600
						  zoneDescription\h - 600
						EndIf
					Case 9
						zoneTexte\x + co
						If zoneTexte\x > 799
						  zoneTexte\x - 800
						EndIf
					Case 10
						zoneTexte\y + co
						If zoneTexte\y > 599
						  zoneTexte\y - 600
						EndIf
					Case 11
						zoneTexte\w + co
						If zoneTexte\w > 800
						  zoneTexte\w - 800
						EndIf
					Case 12
						zoneTexte\h + co
						If zoneTexte\h > 600
						  zoneTexte\h - 600
						EndIf
					Case 13
						zoneInventaire\x + co
						If zoneInventaire\x > 799
						  zoneInventaire\x - 800
						EndIf
					Case 14
						zoneInventaire\y + co
						If zoneInventaire\y > 599
						  zoneInventaire\y - 600
						EndIf
					Case 15
						zoneInventaire\w + co
						If zoneInventaire\w > 800
						  zoneInventaire\w - 800
						EndIf
					Case 16
						zoneInventaire\h + co
						If zoneInventaire\h > 600
						  zoneInventaire\h - 600
						EndIf
					Case 17
						maxInv + co
						If maxInv > 255
						  maxInv - 256
						EndIf
					Case 18
						maxMain + co
						If maxMain > 255
						  maxMain - 256
						EndIf
				EndSelect
				drawPage()
			EndIf
			If roll < 0
				Select PrinSel
					Case 1
						zoneImage\x - co
						If zoneImage\x < 0
						  zoneImage\x + 800
						EndIf
					Case 2
						zoneImage\y - co
						If zoneImage\y < 0
						  zoneImage\y + 600
						EndIf
					Case 3
						zoneImage\w - co
						If zoneImage\w < 1
						  zoneImage\w + 800
						EndIf
					Case 4
						zoneImage\h - co
						If zoneImage\h < 1
						  zoneImage\h + 600
						EndIf
					Case 5
						zoneDescription\x - co
						If zoneDescription\x < 0
						  zoneDescription\x + 800
						EndIf
					Case 6
						zoneDescription\y - co
						If zoneDescription\y < 0
						  zoneDescription\y + 600
						EndIf
					Case 7
						zoneDescription\w - co
						If zoneDescription\w < 1
						  zoneDescription\w + 800
						EndIf
					Case 8
						zoneDescription\h - co
						If zoneDescription\h < 1
						  zoneDescription\h + 600
						EndIf
					Case 9
						zoneTexte\x - co
						If zoneTexte\x < 0
						  zoneTexte\x + 800
						EndIf
					Case 10
						zoneTexte\y - co
						If zoneTexte\y < 0
						  zoneTexte\y + 600
						EndIf
					Case 11
						zoneTexte\w - co
						If zoneTexte\w < 1
						  zoneTexte\w + 800
						EndIf
					Case 12
						zoneTexte\h - co
						If zoneTexte\h < 1
						  zoneTexte\h + 600
						EndIf
					Case 13
						zoneInventaire\x - co
						If zoneInventaire\x < 0
						  zoneInventaire\x + 800
						EndIf
					Case 14
						zoneInventaire\y - co
						If zoneInventaire\y < 0
						  zoneInventaire\y + 600
						EndIf
					Case 15
						zoneInventaire\w - co
						If zoneInventaire\w < 1
						  zoneInventaire\w + 800
						EndIf
					Case 16
						zoneInventaire\h - co
						If zoneInventaire\h < 1
						  zoneInventaire\h + 600
						EndIf
					Case 17
						maxInv - co
						If maxInv < 0
						  maxInv + 256
						EndIf
					Case 18
						maxMain - co
						If maxMain < 0
						  maxMain + 256
						EndIf
				EndSelect
				drawPage()
			EndIf
		Case menuVocabulaire
		  If roll > 0
		    obj = 5
		  EndIf
		  If roll < 0
		    obj = 6
		  EndIf
		Case menuTexteMessages
			If roll > 0
				numeroMessage + co
				If numeroMessage > 255
				  numeroMessage - 256
				EndIf
				drawPage()
			EndIf
			If roll < 0
				numeroMessage - co
				If numeroMessage < 0
				  numeroMessage + 256
				EndIf
				drawPage()
			EndIf
		Case menuTexteSalles
			If roll > 0
				numeroSalle + co
				If numeroSalle > 252
				  numeroSalle - 253
				EndIf
				drawPage()
			EndIf
			If roll < 0
				numeroSalle - co
				If numeroSalle < 0
				  numeroSalle + 253
				EndIf
				drawPage()
			EndIf
		Case menuDeplacements
			If roll > 0
				If dirSel = 0
					numeroSalleDir + co
					If numeroSalleDir > 255
					  numeroSalleDir - 256
  				EndIf
				Else
					dir(numeroSalleDir,dirSel - 1) + co
					If dir(numeroSalleDir,dirSel - 1) > 255
					  dir(numeroSalleDir,dirSel - 1) - 256
  				EndIf
				EndIf
				drawPage()
			EndIf
			If roll < 0
				If dirSel = 0
					numeroSalleDir - co
					If numeroSalleDir < 0
					  numeroSalleDir + 256
  				EndIf
				Else
					dir(numeroSalleDir,dirSel - 1) - co
					If dir(numeroSalleDir,dirSel - 1) < 0
					  dir(numeroSalleDir,dirSel - 1) + 256
  				EndIf
				EndIf
				drawPage()
			EndIf
		Case menuTexteObjets
			If roll > 0
				numeroObjet + co
				If numeroObjet > 255
				  numeroObjet - 256
  		  EndIf
				drawPage()
			EndIf
			If roll < 0
				numeroObjet - co
				If numeroObjet < 0
				  numeroObjet + 256
  		  EndIf
				drawPage()
			EndIf
		Case menuPlacerObjets
			If roll > 0
				If ObjLieuSel = 0
					numeroObjetLieu + co
					If numeroObjetLieu > 255
					  numeroObjetLieu - 256
    		  EndIf
				Else
					objLieu(numeroObjetLieu) + co
					If objLieu(numeroObjetLieu) > 255
					  objLieu(numeroObjetLieu) - 256
    		  EndIf
				EndIf
				drawPage()
			EndIf
			If roll < 0
				If ObjLieuSel = 0
					numeroObjetLieu - co
					If numeroObjetLieu < 0
					  numeroObjetLieu + 256
    		  EndIf
				Else
					objLieu(numeroObjetLieu) - co
					If objLieu(numeroObjetLieu) < 0
					  objLieu(numeroObjetLieu) + 256
    		  EndIf
				EndIf
				drawPage()
			EndIf			
		Case menuEvtsMineurs
			If roll > 0
				If EMinSel = 0
					EMinVerbe(numCondAct) + co
					If EMinVerbe(numCondAct) > 255
					  EMinVerbe(numCondAct) - 256
    		  EndIf
				ElseIf EMinSel = 1
					EMinObjet1(numCondAct) + co
					If EMinObjet1(numCondAct) > 255
					  EMinObjet1(numCondAct) - 256
    		  EndIf
				ElseIf EMinSel = 2
					EMinObjet2(numCondAct) + co
					If EMinObjet2(numCondAct) > 255
					  EMinObjet2(numCondAct) - 256
    		  EndIf
				ElseIf EMinSel = 39
					If EMinCondAct = EM_CONDITIONS And supprCond > -1
						supprCond - co
						If supprCond < 0
						  supprCond = 0
      		  EndIf
					ElseIf EMinCondAct = EM_ACTIONS And supprAct > -1
						supprAct - co
						If supprAct < 0
						  supprAct = 0
      		  EndIf
					EndIf						
				Else
					If EMinCondAct = EM_CONDITIONS And zoneCond > 0
						numCond(indC1,indC2,indC3) + co
						If numCond(indC1,indC2,indC3) > 255
						  numCond(indC1,indC2,indC3) - 256
      		  EndIf
					Else
						numAct(indA1,indA2,indA3) + co
						If numAct(indA1,indA2,indA3) > 255
						  numAct(indA1,indA2,indA3) - 256
      		  EndIf
					EndIf
				EndIf
				drawPage()
			EndIf
			If roll < 0
				If EMinSel = 0
					EMinVerbe(numCondAct) - co
					If EMinVerbe(numCondAct) < 0
					  EMinVerbe(numCondAct) + 256
    		  EndIf
				ElseIf EMinSel = 1
					EMinObjet1(numCondAct) - co
					If EMinObjet1(numCondAct) < 0
					  EMinObjet1(numCondAct) + 256
    		  EndIf
				ElseIf EMinSel = 2
					EMinObjet2(numCondAct) - co
					If EMinObjet2(numCondAct) < 0
					  EMinObjet2(numCondAct) + 256
    		  EndIf
				ElseIf EMinSel = 39
					If EMinCondAct = EM_CONDITIONS And supprCond > -1
						supprCond + co
						If supprCond > 24
						  supprCond = 24
      		  EndIf
					ElseIf EMinCondAct = EM_ACTIONS And supprAct > -1
						supprAct + co
						If supprAct > 24
						  supprAct = 24
      		  EndIf
					EndIf						
				Else
					If EMinCondAct = EM_CONDITIONS And zoneCond > 0
						numCond(indC1,indC2,indC3) - co
						If numCond(indC1,indC2,indC3) < 0
						  numCond(indC1,indC2,indC3) + 256
      		  EndIf
					Else
						numAct(indA1,indA2,indA3) - co
						If numAct(indA1,indA2,indA3) < 0
						  numAct(indA1,indA2,indA3) + 256
      		  EndIf
					EndIf
				EndIf
				drawPage()
			EndIf			
		Case menuEvtsMajeurs
			If roll > 0
				If EMajSel = 39
					If EMajCondAct = EM_CONDITIONS And supprCondMaj > -1
						supprCondMaj - co
						If supprCondMaj < 0
						  supprCondMaj = 0
  					EndIf						
					ElseIf EMajCondAct = EM_ACTIONS And supprActMaj > -1
						supprActMaj - co
						If supprActMaj < 0
						  supprActMaj = 0
  					EndIf						
					EndIf						
				ElseIf EMajSel > 0
					If EMajCondAct = EM_CONDITIONS And zoneCondMaj > 0
						numCondMaj(indC1Maj,indC2Maj,indC3Maj) + co
						If numCondMaj(indC1Maj,indC2Maj,indC3Maj) > 255
						  numCondMaj(indC1Maj,indC2Maj,indC3Maj) - 256
  					EndIf						
					Else
						numActMaj(indA1Maj,indA2Maj,indA3Maj) + co
						If numActMaj(indA1Maj,indA2Maj,indA3Maj) > 255
						  numActMaj(indA1Maj,indA2Maj,indA3Maj) - 256
  					EndIf						
					EndIf
				EndIf
				drawPage()
			EndIf
			If roll < 0
				If EMajSel = 39
					If EMajCondAct = EM_CONDITIONS And supprCondMaj > -1
						supprCondMaj + co
						If supprCondMaj > 24
						  supprCondMaj = 24
  					EndIf						
					ElseIf EMajCondAct = EM_ACTIONS And supprActMaj > -1
						supprActMaj + co
						If supprActMaj > 24
						  supprActMaj = 24
  					EndIf						
					EndIf						
				ElseIf EMajSel > 0
					If EMajCondAct = EM_CONDITIONS And zoneCondMaj > 0
						numCondMaj(indC1Maj,indC2Maj,indC3Maj) - co
						If numCondMaj(indC1Maj,indC2Maj,indC3Maj) < 0
						  numCondMaj(indC1Maj,indC2Maj,indC3Maj) + 256
  					EndIf						
					Else
						numActMaj(indA1Maj,indA2Maj,indA3Maj) - co
						If numActMaj(indA1Maj,indA2Maj,indA3Maj) < 0
						  numActMaj(indA1Maj,indA2Maj,indA3Maj) + 256
  					EndIf
					EndIf
				EndIf
				drawPage()
			EndIf			
		Case menuMessageSystemes
			If roll > 0
				numeroMsgSys + co
				If numeroMsgSys > 25
				  numeroMsgSys - 26
				EndIf
				drawPage()
			EndIf
			If roll < 0
				numeroMsgSys - co
				If numeroMsgSys < 0
				  numeroMsgSys + 26
				EndIf
				drawPage()
			EndIf
		Case menuSauverFichier,menuChargerFichier
			If roll > 0
				baseDir - co
				updatedDirs(baseDir,dirCount)
				drawPage()
			EndIf
			If roll < 0
				baseDir + co
				updatedDirs(baseDir,dirCount)
				drawPage()
			EndIf
		Case menuAttribObjets
			If roll > 0
				If attrSel = 0
					numeroAttribObjet + co
					If numeroAttribObjet > 255
					  numeroAttribObjet - 256
  				EndIf
				ElseIf attrSel = 1
					attr(numeroAttribObjet,attrSel - 1) + co
					If attr(numeroAttribObjet,attrSel - 1) > 255
					  attr(numeroAttribObjet,attrSel - 1) - 256
  				EndIf
				ElseIf attrSel > 1
					attr(numeroAttribObjet,attrSel - 1) = #True
			 	EndIf
				drawPage()
			EndIf
			If roll < 0
				If attrSel = 0
					numeroAttribObjet - co
					If numeroAttribObjet < 0
					  numeroAttribObjet + 256
					EndIf
				ElseIf attrSel = 1
					attr(numeroAttribObjet,attrSel - 1) - co
					If attr(numeroAttribObjet,attrSel - 1) < 0
					  attr(numeroAttribObjet,attrSel - 1) + 256
					EndIf
				ElseIf attrSel > 1
					attr(numeroAttribObjet,attrSel - 1) = #False
			 	EndIf			
				drawPage()
			EndIf			
	EndSelect
EndIf

If cn And Not kb
	Select menuType
		Case menuVocabulaire
			If roll > 0
				monNombre1 + co
				If monNombre1 > 255
				  monNombre1 - 256
  			EndIf
				drawPage()
			EndIf
			If roll < 0
				monNombre1 - co
				If monNombre1 < 0
				  monNombre1 + 256
  			EndIf
				drawPage()
			EndIf
			If KeyReturn = #True
				cn = #False
				For i = 0 To 9
					If verb(monNombre1,i) = ""
						kb = #True
						v$ = ""
						kbType = KBINST
						monNombre2 = i
						Break
					EndIf
				Next
				drawPage()
			EndIf
	EndSelect
EndIf

; Gestion clavier/saisie
If kb And Not cn
	Select menuType
		Case menuVocabulaire
		  ch = GetKey
		  If KeyBack = #True
		    ch = 8
		  ElseIf KeyReturn = #True
		    ch = 13
		  EndIf
			If ch = 8 And Len(v$) > 0
				v$ = Left(v$,Len(v$) - 1)
				drawPage()
			ElseIf ch = 13 And Len(v$) > 0
				If kbType = KBEDIT
					verb(verbselx,verbsely) = v$
					kb = #False
				ElseIf  kbType = KBINST
					verb(monNombre1,monNombre2) = v$
					kb = #False
					verbx = monNombre1
					verby = monNombre2
					verbselx = verbx
					verbsely = verby
				EndIf
				drawPage()
			ElseIf ch > 31 And Len(v$) <= 11
				a$ = UCase(Chr(ch))
				If a$ >= "A" And a$ <= "Z"
					v$ = v$ + a$
					drawPage()
				EndIf
			EndIf
		Case menuTexteMessages
		  ch = GetKey
		  If KeyBack = #True
		    ch = 8
		  ElseIf KeyReturn = #True
		    ch = 13
		  EndIf  
		  If ch = 8 And Len(v$) > 0
				v$ = Left(v$,Len(v$) - 1)
				msg(numeroMessage) = v$
				drawPage()
			ElseIf ch = 13 And Len(v$) > 0
				If kbType = KBEDIT
					msg(numeroMessage) = v$
          circonflexe = #False
          trema = #False
					kb = #False
				EndIf
				drawPage()
      ElseIf ch > 31
        a$ = Chr(ch)
        circonflexe = #False
        trema = #False
				v$ = v$ + a$
				msg(numeroMessage) = v$
				drawPage()
			EndIf
		Case menuTexteSalles
			ch = GetKey
		  If KeyBack = #True
		    ch = 8
		  ElseIf KeyReturn = #True
		    ch = 13
		  EndIf  
			If ch = 8 And Len(v$) > 0
				v$ = Left(v$,Len(v$) - 1)
				lieu(numeroSalle) = v$
				drawPage()
			ElseIf ch = 13 And Len(v$) > 0
				If kbType = KBEDIT
					lieu(numeroSalle) = v$
          circonflexe = #False
          trema = #False
					kb = #False
				EndIf
				drawPage()
      ElseIf ch > 31
        a$ = Chr(ch)
        circonflexe = #False
        trema = #False
				v$ = v$ + a$
				lieu(numeroSalle) = v$
				drawPage()
			EndIf
		Case menuTexteObjets
			ch = GetKey
		  If KeyBack = #True
		    ch = 8
		  ElseIf KeyReturn = #True
		    ch = 13
		  EndIf  
			If ch = 8 And Len(v$) > 0
				v$ = Left(v$,Len(v$) - 1)
				objet(numeroObjet) = v$
				drawPage()
			ElseIf ch = 13 And Len(v$) > 0
				If kbType = KBEDIT
					objet(numeroObjet) = v$
          circonflexe = #False
          trema = #False
					kb = #False
				EndIf
				drawPage()
      ElseIf ch > 31
        a$ = Chr(ch)
        circonflexe = #False
        trema = #False
				v$ = v$ + a$
				objet(numeroObjet) = v$
				drawPage()
			EndIf
		Case menuMessageSystemes
			ch = GetKey
		  If KeyBack = #True
		    ch = 8
		  ElseIf KeyReturn = #True
		    ch = 13
		  EndIf  
			If ch = 8 And Len(v$) > 0
				v$ = Left(v$,Len(v$) - 1)
				sys(numeroMsgSys) = v$
				drawPage()
			ElseIf ch = 13 And Len(v$) > 0
				If kbType = KBEDIT
					sys(numeroMsgSys) = v$
          circonflexe = #False
          trema = #False
					kb = #False
				EndIf
				drawPage()
      ElseIf ch > 31
        a$ = Chr(ch)
				v$ = v$ + a$
				sys(numeroMsgSys) = v$
				drawPage()
			EndIf
		Case menuSauverFichier
			ch = GetKey
		  If KeyBack = #True
		    ch = 8
		  ElseIf KeyReturn = #True
		    ch = 13
		  EndIf  
			If ch = 8 And Len(v$) > 0
				v$ = Left(v$,Len(v$) - 1)
				savedGame$ = v$
				drawPage()
			ElseIf ch = 13 And Len(v$) > 0
				If kbType = KBEDIT
					savedGame$ = v$
          circonflexe = #False
          trema = #False
					kb = #False
				EndIf
				drawPage()			
      ElseIf ch > 31
        a$ = Chr(ch)
        circonflexe = #False
        trema = #False
				v$ = v$ + noForbidenChar(a$)
				savedGame$ = v$
				drawPage()
			EndIf
	EndSelect
EndIf

; Réagir en fonction de la page et de l'objet
If obj > 0
	Select menuType
		Case menuPrincipal
			Prinsel = 0
			If obj = 1
				menuType = menuVocabulaire
			ElseIf obj = 2
				menuType = menuTexteMessages
			ElseIf obj = 3
				menuType = menuTexteSalles
			ElseIf obj = 4
				menuType = menuDeplacements
			ElseIf obj = 5
				menuType = menuTexteObjets
			ElseIf obj = 6
				menuType = menuPlacerObjets
			ElseIf obj = 7
				menuType = menuEvtsMineurs
			ElseIf obj = 8
				menuType = menuEvtsMajeurs
			ElseIf obj = 9
				menuType = menuMessageSystemes
			ElseIf obj = 10
				menuType = menuMultimedia
			ElseIf obj = 11
				menuType = menuSauverFichier
				baseDir = 0
				updatedDirs(baseDir,dirCount)
			ElseIf obj = 12
				menuType = menuChargerFichier
				baseDir = 0
				updatedDirs(baseDir,dirCount)
			ElseIf obj = 13
				menuType = menuAttribObjets
			ElseIf obj = 14
				menuType = menuTesterJeu
			ElseIf obj = 15
				initVars()
				init()
			ElseIf obj = 16
				MainLoop = #False
				Break
			ElseIf obj > 16
				PrinSel = obj - 16
			EndIf
		Case menuVocabulaire
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				If verb(verbselx,verbsely) <> ""
					vx = verbselx
					vy = verbsely
					doNotClear = #False
					If verbpos = POSMIDDLE
						If findNextSelVerb() = #True
						  If verbpos = POSBOTTOM
						    findNextVerb()
						  EndIf
						Else
							If findBackSelVerb() = #True
							  If verbpos = POSTOP
							    findBackVerb()
							  EndIf
							EndIf
						EndIf
					Else
						If findNextSelVerb() = #False
							If findBackSelVerb() = #True
							  If verbpos = POSTOP
							    findBackVerb()
							  EndIf
							Else
								doNotClear = #True
							EndIf
						Else
							findNextVerb()
						EndIf
					EndIf
					If doNotClear = #False
					  verb(vx,vy) = ""
					EndIf
				EndIf
			ElseIf obj = 3
				kb = #True
				v$ = verb(verbselx,verbsely)
				kbType = KBEDIT
			ElseIf obj = 4
				cn = #True
				monNombre1 = 0
			ElseIf obj = 5
			  For i = 1 To co
  				If findBackSelVerb() = #True
	  			  If verbpos = POSTOP
	  			    findBackVerb()
			  	  EndIf
			  	EndIf
 			    drawPage()
			  Next
			ElseIf obj = 6
			  For i = 1 To co
  				If findNextSelVerb() = #True
	  			  If verbpos = POSBOTTOM
		  		    findNextVerb()
			  	  EndIf
			  	EndIf
 			    drawPage()
			  Next
			EndIf
		Case menuTexteMessages
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				msg(numeroMessage) = ""
			ElseIf obj = 3
				kb = #True
				v$ = msg(numeroMessage)
				kbType = KBEDIT
			EndIf
		Case menuTexteSalles
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				lieu(numeroSalle) = ""
			ElseIf obj = 3
				kb = #True
				v$ = lieu(numeroSalle)
				kbType = KBEDIT
			EndIf
		Case menuDeplacements
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj > 1
				dirSel = obj - 2
			EndIf
		Case menuTexteObjets
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				objet(numeroObjet) = ""
			ElseIf obj = 3
				kb = #True
				v$ = objet(numeroObjet)
				kbType = KBEDIT
			EndIf
		Case menuPlacerObjets
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj > 1
				ObjLieuSel = obj - 2
			EndIf
		Case menuEvtsMineurs
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				If numCondAct + 1 < condActCount
					numCondAct + 1
					zoneCond = 0
					zoneAct = 0
					EMinSel = 0
					If numCond(0,0,numCondAct) = -1
						supprCond = -1
					ElseIf numCond(0,0,numCondAct) > -1 And supprCond = -1
						supprCond = 0
					EndIf
					If numAct(0,0,numCondAct) = -1
						supprAct = -1
					ElseIf numAct(0,0,numCondAct) > -1 And supprAct = -1
						supprAct = 0
					EndIf
				EndIf			
			ElseIf obj = 3
				If numCondAct > 0
					numCondAct - 1
					zoneCond = 0
					zoneAct = 0
					EMinSel = 0
					If numCond(0,0,numCondAct) = -1
						supprCond = -1
					ElseIf numCond(0,0,numCondAct) > -1 And supprCond = -1
						supprCond = 0
					EndIf
					If numAct(0,0,numCondAct) = -1
						supprAct = -1
					ElseIf numAct(0,0,numCondAct) > -1 And supprAct = -1
						supprAct = 0
					EndIf
				EndIf			
			ElseIf obj = 4
				If condActCount < 1000
					condActCount + 1
					numCondAct = condActCount - 1
					zoneCond = 0
					zoneAct = 0
					EMinSel = 0					
					If numCond(0,0,numCondAct) = -1
						supprCond = -1
					ElseIf numCond(0,0,numCondAct) > -1 And supprCond = -1
						supprCond = 0
					EndIf
					If numAct(0,0,numCondAct) = -1
						supprAct = -1
					ElseIf numAct(0,0,numCondAct) > -1 And supprAct = -1
						supprAct = 0
					EndIf
				EndIf
			ElseIf obj = 5 Or obj = 6 Or obj = 7
				EMinSel = obj - 5
			ElseIf obj = 8
			  If EMinCondAct = EM_CONDITIONS
			    EMinCondAct = EM_ACTIONS
			  Else
			    EMinCondAct = EM_CONDITIONS
			  EndIf
			ElseIf obj >= 9 And obj <= 9 + 13 And EMinCondAct = EM_CONDITIONS
				For i = 0 To 24
					If numCond(i,0,numCondAct) = -1
						numCond(i,0,numCondAct) = obj - 9
						numCond(i,1,numCondAct) = 255
						numCond(i,2,numCondAct) = 255
						numCond(i,3,numCondAct) = 255
						supprCond = 0
						Break
					EndIf
				Next
			ElseIf obj >= 9 And obj <= 9 + 24 And EMinCondAct = EM_ACTIONS
				For i = 0 To 24
					If numAct(i,0,numCondAct) = -1
						numAct(i,0,numCondAct) = obj - 9
						numAct(i,1,numCondAct) = 255
						numAct(i,2,numCondAct) = 255
						numAct(i,3,numCondAct) = 255
						supprAct = 0
						Break
					EndIf
				Next
			ElseIf obj = 40
				EMinSel = 39
				zoneCond = -1
				zoneAct = -1
			ElseIf obj >= minZC2 + 1 And obj <= minZC2 + longZC2
				If EMinCondAct = EM_CONDITIONS
					zoneCond = obj
					EMinSel = 3
				ElseIf EMinCondAct = EM_ACTIONS
					zoneAct = obj
					EMinSel = 3
				EndIf
			EndIf
		Case menuEvtsMajeurs
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				If numCondActMaj + 1 < condActCountMaj
					numCondActMaj + 1
					zoneCondMaj = 0
					zoneActMaj = 0
					EMajSel = 0
					If numCondMaj(0,0,numCondActMaj) = -1
						supprCondMaj = -1
					ElseIf numCondMaj(0,0,numCondActMaj) > -1 And supprCondMaj = -1
						supprCondMaj = 0
					EndIf
					If numActMaj(0,0,numCondActMaj) = -1
						supprActMaj = -1
					ElseIf numActMaj(0,0,numCondActMaj) > -1 And supprActMaj = -1
						supprActMaj = 0
					EndIf
				EndIf			
			ElseIf obj = 3
				If numCondActMaj > 0
					numCondActMaj - 1
					zoneCondMaj = 0
					zoneActMaj = 0
					EMajSel = 0
					If numCondMaj(0,0,numCondActMaj) = -1
						supprCondMaj = -1
					ElseIf numCondMaj(0,0,numCondActMaj) > -1 And supprCondMaj = -1
						supprCondMaj = 0
					EndIf
					If numActMaj(0,0,numCondActMaj) = -1
						supprActMaj = -1
					ElseIf numActMaj(0,0,numCondActMaj) > -1 And supprActMaj = -1
						supprActMaj = 0
					EndIf
				EndIf			
			ElseIf obj = 4
				If condActCountMaj < 1000
					condActCountMaj + 1
					numCondActMaj = condActCountMaj - 1
					zoneCondMaj = 0
					zoneActMaj = 0
					EMajSel = 0					
					If numCondMaj(0,0,numCondActMaj) = -1
						supprCondMaj = -1
					ElseIf numCondMaj(0,0,numCondActMaj) > -1 And supprCondMaj = -1
						supprCondMaj = 0
					EndIf
					If numActMaj(0,0,numCondActMaj) = -1
						supprActMaj = -1
					ElseIf numActMaj(0,0,numCondActMaj) > -1 And supprActMaj = -1
						supprActMaj = 0
					EndIf
				EndIf
			ElseIf obj = 5
			  If EMajCondAct = EM_CONDITIONS
			    EMajCondAct = EM_ACTIONS
			  Else
			    EMajCondAct = EM_CONDITIONS
			  EndIf
			ElseIf obj >= 6 And obj <= 6 + 13 And EMajCondAct = EM_CONDITIONS
				For i = 0 To 24
					If numCondMaj(i,0,numCondActMaj) = -1
						numCondMaj(i,0,numCondActMaj) = obj - 6
						numCondMaj(i,1,numCondActMaj) = 255
						numCondMaj(i,2,numCondActMaj) = 255
						numCondMaj(i,3,numCondActMaj) = 255
						supprCondMaj = 0
						Break
					EndIf
				Next
			ElseIf obj >= 6 And obj <= 6 + 24 And EMajCondAct = EM_ACTIONS
				For i = 0 To 24
					If numActMaj(i,0,numCondActMaj) = -1
						numActMaj(i,0,numCondActMaj) = obj - 6
						numActMaj(i,1,numCondActMaj) = 255
						numActMaj(i,2,numCondActMaj) = 255
						numActMaj(i,3,numCondActMaj) = 255
						supprActMaj = 0
						Break
					EndIf
				Next
			ElseIf obj = 40
				EMajSel = 39
				zoneCondMaj = -1
				zoneActMaj = -1
			ElseIf obj >= minZC2 + 1 And obj <= minZC2 + longZC2
				If EMajCondAct = EM_CONDITIONS
					zoneCondMaj = obj
					EMajSel = 2
				ElseIf EMajCondAct = EM_ACTIONS
					zoneActMaj = obj
					EMajSel = 2
				EndIf
			EndIf
		Case menuMessageSystemes
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				sys(numeroMsgSys) = ""
			ElseIf obj = 3
				kb = #True
				v$ = sys(numeroMsgSys)
				kbType = KBEDIT
			EndIf
		Case menuMultimedia
			If obj = 1
				menuType = menuPrincipal
			EndIf		
		Case menuSauverFichier
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj = 2
				savedGame$ = ""
			ElseIf obj = 3
				kb = #True
				v$ = savedGame$
				kbType = KBEDIT
			ElseIf obj = 4
				If savedGame$ <> ""
					gameDir$ = "Projets"+SL+savedGame$+SL
					If FileSize(gameDir$) = -2
						CreateDirectory(gameDir$)
						baseDir = 0
						updatedDirs(baseDir,dirCount)
						saveJad(savedGame$+".jad",gameDir$)
					EndIf
				EndIf
			EndIf
		Case menuChargerFichier
			If obj = 1
				menuType = menuPrincipal
			ElseIf obj > 1
				If tenDirs(obj - 2) <> ""
					savedGame$ = tenDirs(obj - 2)
					gameDir$ = "Projets"+SL+savedGame$+SL
					loadJad(savedGame$+".jad",gameDir$)
				EndIf
			EndIf
		Case menuAttribObjets
			If obj >= 1 And obj <= 4
				attrSel = obj - 1
			ElseIf obj = 5
				menuType = menuPrincipal
			EndIf
	EndSelect
	drawPage()
ElseIf menuType = menuPrincipal And objClicked
	Prinsel = 0
	drawPage()
EndIf

obj = 0

Wend

CloseWindow(0)
End

; FONCTIONS ----------------------------------------------

; Centrer un texte et choisir sa couleur
Procedure centerText(t$,x,y,r,g,b)
DrawingMode(#PB_2DDrawing_Transparent)
FrontColor(RGB(r,g,b))
DrawText(x - (TextWidth(t$) / 2),y - (TextHeight(t$) / 2), t$)
EndProcedure

; Afficher à gauche un texte et choisir sa couleur
Procedure leftText(t$,x,y,r,g,b)
FrontColor(RGB(r,g,b))
DrawText(x,y,t$)
EndProcedure

; Afficher un bouton blanc avec ombree noire
Procedure boutonBlanc(x,y,w,h)
FrontColor(RGB(0,0,0))
Box(x,y,w,h)
Box(x+2,y+2,w,h)
FrontColor(RGB(255,255,255))
Box(x+1,y+1,w-2,h-2)
EndProcedure

; Afficher un bouton flêche noire
Procedure boutonFleche(x,y,w,h,sens)
FrontColor(RGB(0,0,0))
r.f = w
r / h
If sens = FLECHEHAUT
	For ver = y To y + h - 1
		LineXY(x + (w / 2) - ((ver - y) * r), ver, x + (w / 2) + ((ver - y) * r), ver)
	Next
Else
	For ver = y + h - 1 To y Step - 1
		LineXY(x + (w / 2) - ((ver - (y + h - 1)) * r), ver, x + (w / 2) + ((ver - (y + h - 1)) * r), ver)
	Next
EndIf
EndProcedure

; Afficher le menu principal
Procedure menu()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
centerText("MENU",400,16,0,0,0)
Dim listeMenu.s(16)
listeMenu(0) = "VOCABULAIRE"
listeMenu(1) = "TEXTE MESSAGES"
listeMenu(2) = "TEXTE SALLES"
listeMenu(3) = "DEPLACEMENTS"
listeMenu(4) = "TEXTE OBJETS"
listeMenu(5) = "PLACER OBJETS"
listeMenu(6) = "EVTS. MINEURS"
listeMenu(7) = "EVTS. MAJEURS"
listeMenu(8) = "MESS. SYSTEMES"
listeMenu(9) = "MULTIMEDIA"
listeMenu(10) = "SAUVER FICHIER"
listeMenu(11) = "CHARGER FICHIER"
listeMenu(12) = "ATTRIB. OBJETS"
listeMenu(13) = "TESTER JEU"
listeMenu(14) = "REINITIALISER"
listeMenu(15) = "QUITTER"
i = 0
For y = 0 To 7
	For x = 0 To 1
		boutonBlanc(33 + (383 * x), (35 * (y + 1)), 350, 30)
		centerText(listeMenu(i),33 + (383 * x) + (350 / 2), (35 * (y + 1)) + (30 / 2),0,0,0)
		zoneClick(i,0) = i + 1
		zoneClick(i,1) = 33 + (383 * x)
		zoneClick(i,2) = (35 * (y + 1))
		zoneClick(i,3) = 350
		zoneClick(i,4) = 30	
		i+1
	Next
Next
leftText("ZONE IMAGE",33,350,0,0,0)
leftText("ZONE DESCRIPTION",33,380,0,0,0)
leftText("ZONE TEXTE",33,410,0,0,0)
leftText("ZONE INVENTAIRE",33,440,0,0,0)
leftText("MAX. OBJETS EN INVENTAIRE",33,470,0,0,0)
leftText("MAX. OBJETS EN MAIN",33,500,0,0,0)
FrontColor(RGB(255,0,0))
Box(400,350,TextWidth("000"),TextHeight("000"))
Box(450,350,TextWidth("000"),TextHeight("000"))
Box(500,350,TextWidth("000"),TextHeight("000"))
Box(550,350,TextWidth("000"),TextHeight("000"))
Box(400,380,TextWidth("000"),TextHeight("000"))
Box(450,380,TextWidth("000"),TextHeight("000"))
Box(500,380,TextWidth("000"),TextHeight("000"))
Box(550,380,TextWidth("000"),TextHeight("000"))
Box(400,410,TextWidth("000"),TextHeight("000"))
Box(450,410,TextWidth("000"),TextHeight("000"))
Box(500,410,TextWidth("000"),TextHeight("000"))
Box(550,410,TextWidth("000"),TextHeight("000"))
Box(400,440,TextWidth("000"),TextHeight("000"))
Box(450,440,TextWidth("000"),TextHeight("000"))
Box(500,440,TextWidth("000"),TextHeight("000"))
Box(550,440,TextWidth("000"),TextHeight("000"))
Box(400,470,TextWidth("000"),TextHeight("000"))
Box(400,500,TextWidth("000"),TextHeight("000"))
For y = 0 To 3
	For x = 0 To 3
		zoneClick(i,0) = i + 1
		zoneClick(i,1) = 400 + (x * 50)
		zoneClick(i,2) = 350 + (y * 30)
		zoneClick(i,3) = TextWidth("000")
		zoneClick(i,4) = TextHeight("000")
		i+1
	Next
Next
zoneClick(i,0) = i + 1
zoneClick(i,1) = 400
zoneClick(i,2) = 470
zoneClick(i,3) = TextWidth("000")
zoneClick(i,4) = TextHeight("000")
i+1
zoneClick(i,0) = i + 1
zoneClick(i,1) = 400
zoneClick(i,2) = 500
zoneClick(i,3) = TextWidth("000")
zoneClick(i,4) = TextHeight("000")
i+1
If PrinSel = 1
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(400,350,zeros(zoneImage\x))
If PrinSel = 2
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(450,350,zeros(zoneImage\y))
If PrinSel = 3
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(500,350,zeros(zoneImage\w))
If PrinSel = 4
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(550,350,zeros(zoneImage\h))
If PrinSel = 5
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(400,380,zeros(zoneDescription\x))
If PrinSel = 6
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(450,380,zeros(zoneDescription\y))
If PrinSel = 7
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(500,380,zeros(zoneDescription\w))
If PrinSel = 8
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(550,380,zeros(zoneDescription\h))
If PrinSel = 9
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(400,410,zeros(zoneTexte\x))
If PrinSel = 10
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(450,410,zeros(zoneTexte\y))
If PrinSel = 11
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(500,410,zeros(zoneTexte\w))
If PrinSel = 12
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(550,410,zeros(zoneTexte\h))
If PrinSel = 13
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(400,440,zeros(zoneInventaire\x))
If PrinSel = 14
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(450,440,zeros(zoneInventaire\y))
If PrinSel = 15
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(500,440,zeros(zoneInventaire\w))
If PrinSel = 16
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(550,440,zeros(zoneInventaire\h))
If PrinSel = 17
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(400,470,zeros(maxInv))
If PrinSel = 18
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(400,500,zeros(maxMain))
StopDrawing()
EndProcedure

; Afficher le menu Vocabulaire
Procedure menuVoc()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("VOCABULAIRE",60 + (TextWidth("VOCABULAIRE") / 2),35,0,0,0)
Dim listeMenu.s(4)
listeMenu(0) = "MENU"
listeMenu(1) = "EFFA"
listeMenu(2) = "EDIT"
listeMenu(3) = "INST"
i = 0
For y = 0 To 3
	boutonBlanc(100, 200 + (35 * (y + 1)), 80, 30)
	centerText(listeMenu(i),140, 200 + (35 * (y + 1)) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 100
	zoneClick(i,2) = 200 + (35 * (y + 1))
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
boutonFleche(120,210,10,10,FLECHEHAUT)
zoneClick(4,0) = 5
zoneClick(4,1) = 120
zoneClick(4,2) = 210
zoneClick(4,3) = 10
zoneClick(4,4) = 10	
boutonFleche(150,210,10,10,FLECHEBAS)
zoneClick(5,0) = 6
zoneClick(5,1) = 150
zoneClick(5,2) = 210
zoneClick(5,3) = 10
zoneClick(5,4) = 10
i = 6
boutonBlanc(400,150,200,220)
y = 0
i = verbx
j = verby
While y < 11
	If verb(i,j) <> ""
		a$ = zeros(i)
		If verbselx = i And verbsely = j
			FrontColor(RGB(0,0,0))
			Box(402,152 + (20 * y),196,20)
			leftText(a$ + " " + verb(i,j),420, 152 + (20 * y),255,255,255)
			If y = 0
				verbpos = POSTOP
			ElseIf y = 10
				verbpos = POSBOTTOM
			Else
				verbpos = POSMIDDLE
			EndIf
		Else
			leftText(a$ + " " + verb(i,j),420, 152 + (20 * y),0,0,0)
		EndIf
		y + 1
	EndIf
	j + 1
	If j = 10
		j = 0
		i + 1
		If i > 255
		  Break 
		EndIf
	EndIf
Wend
boutonBlanc(400,380,200,30)
If kb
	cursor$ = "_"
	If kbType = KBEDIT
		a$ = zeros(verbselx)
	ElseIf kbType = KBINST
		a$ = zeros(monNombre1)	
	EndIf
	leftText(a$ + " " + v$ + cursor$,420, 382,0,0,0)
ElseIf cn
	a$ = zeros(monNombre1)
	FrontColor(RGB(255,0,0))
	Box(402,382,196,20)
	leftText(a$,420, 382,255,255,255)
EndIf
DrawingMode(#PB_2DDrawing_AlphaBlend)
DrawImage(ImageID(deco3),200,300)
DrawingMode(#PB_2DDrawing_Default)
StopDrawing()
EndProcedure

; Afficher le menu Texte Messages
Procedure menuTexteMsg()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 80, 700, 30)
centerText("TEXTE MESSAGES",60 + (TextWidth("TEXTE MESSAGES") / 2),95,0,0,0)
Dim listeMenu.s(3)
listeMenu(0) = "MENU"
listeMenu(1) = "EFFA"
listeMenu(2) = "EDIT"
i = 0
For y = 0 To 2
	boutonBlanc(10, 265 + (35 * y), 80, 30)
	centerText(listeMenu(i),50, 265 + (35 * y) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 10
	zoneClick(i,2) = 265 + (35 * y)
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
centerText("MESSAGE",400, 230,0,0,0)
a$ = zeros(numeroMessage)
FrontColor(RGB(255,0,0))
Box(420 + TextWidth("MESSAGE"),230 - (TextHeight("MESSAGE")/2),TextWidth("000"),TextHeight("000"))
leftText(a$,420 + TextWidth("MESSAGE"),230 - (TextHeight("MESSAGE")/2),0,0,0)
boutonBlanc(100,265,690,100)
If kb
  cursor$ = "_"
EndIf
If Not multiLineText(msg(numeroMessage)+cursor$,100,265,690,100,20,20,0,0,0,#False)
	msg(numeroMessage) = Left(msg(numeroMessage),Len(msg(numeroMessage)) - 1)
EndIf
v$ = msg(numeroMessage)
multiLineText(msg(numeroMessage)+cursor$,100,265,690,100,20,20,0,0,0)
DrawingMode(#PB_2DDrawing_AlphaBlend)
DrawImage(ImageID(deco1),137,435)
DrawingMode(#PB_2DDrawing_Default)
StopDrawing()
EndProcedure

; Afficher le menu Texte Salles
Procedure menuTexteLieu()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 80, 700, 30)
centerText("TEXTE SALLES",60 + (TextWidth("TEXTE SALLES") / 2),95,0,0,0)
Dim listeMenu.s(3)
listeMenu(0) = "MENU"
listeMenu(1) = "EFFA"
listeMenu(2) = "EDIT"
i = 0
For y = 0 To 2
	boutonBlanc(10, 265 + (35 * y), 80, 30)
	centerText(listeMenu(i),50, 265 + (35 * y) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 10
	zoneClick(i,2) = 265 + (35 * y)
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
centerText("SALLE",400, 230,0,0,0)
a$ = zeros(numeroSalle)
FrontColor(RGB(255,0,0))
Box(420 + TextWidth("SALLE"),230 - (TextHeight("SALLE")/2),TextWidth("000"),TextHeight("000"))
leftText(a$,420 + TextWidth("SALLE"),230 - (TextHeight("SALLE")/2),0,0,0)
boutonBlanc(100,265,690,100)
If kb
  cursor$ = "_"
EndIf
If Not multiLineText(lieu(numeroSalle)+cursor$,100,265,690,100,20,20,0,0,0,#False)
	lieu(numeroSalle) = Left(lieu(numeroSalle),Len(lieu(numeroSalle)) - 1)
EndIf
v$ = lieu(numeroSalle)
multiLineText(lieu(numeroSalle)+cursor$,100,265,690,100,20,20,0,0,0)
DrawingMode(#PB_2DDrawing_AlphaBlend)
DrawImage(ImageID(deco2),300,350)
DrawingMode(#PB_2DDrawing_Default)
StopDrawing()
EndProcedure

; Afficher le menu Déplacements
Procedure menuDeplace()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("DEPLACEMENTS",60 + (TextWidth("DEPLACEMENTS") / 2),35,0,0,0)
boutonBlanc(75, 200, 170, 200)
leftText("Salle",95,220,0,0,0)
leftText("Nord",95,260,0,0,0)
leftText("Sud",95,280,0,0,0)
leftText("Est",95,300,0,0,0)
leftText("Ouest",95,320,0,0,0)
leftText("Haut",95,340,0,0,0)
leftText("Bas",95,360,0,0,0)
FrontColor(RGB(255,0,0))
Box(175,220,TextWidth("000"),TextHeight("000"))
zoneClick(1,0) = 2
zoneClick(1,1) = 175
zoneClick(1,2) = 220
zoneClick(1,3) = TextWidth("000")
zoneClick(1,4) = TextHeight("000")
Box(175,260,TextWidth("000"),TextHeight("000"))
Box(175,280,TextWidth("000"),TextHeight("000"))
Box(175,300,TextWidth("000"),TextHeight("000"))
Box(175,320,TextWidth("000"),TextHeight("000"))
Box(175,340,TextWidth("000"),TextHeight("000"))
Box(175,360,TextWidth("000"),TextHeight("000"))
Box(750,460,TextWidth("000"),TextHeight("000"))
zoneClick(2,0) = 3
zoneClick(2,1) = 750
zoneClick(2,2) = 460
zoneClick(2,3) = TextWidth("000")
zoneClick(2,4) = TextHeight("000")
Box(330,280,TextWidth("000"),TextHeight("000"))
zoneClick(3,0) = 4
zoneClick(3,1) = 330
zoneClick(3,2) = 280
zoneClick(3,3) = TextWidth("000")
zoneClick(3,4) = TextHeight("000")
Box(330,460,TextWidth("000"),TextHeight("000"))
zoneClick(4,0) = 5
zoneClick(4,1) = 330
zoneClick(4,2) = 460
zoneClick(4,3) = TextWidth("000")
zoneClick(4,4) = TextHeight("000")
Box(750,280,TextWidth("000"),TextHeight("000"))
zoneClick(5,0) = 6
zoneClick(5,1) = 750
zoneClick(5,2) = 280
zoneClick(5,3) = TextWidth("000")
zoneClick(5,4) = TextHeight("000")
Box(530,70,TextWidth("000"),TextHeight("000"))
zoneClick(6,0) = 7
zoneClick(6,1) = 530
zoneClick(6,2) = 70
zoneClick(6,3) = TextWidth("000")
zoneClick(6,4) = TextHeight("000")
Box(530,520,TextWidth("000"),TextHeight("000"))
zoneClick(7,0) = 8
zoneClick(7,1) = 530
zoneClick(7,2) = 520
zoneClick(7,3) = TextWidth("000")
zoneClick(7,4) = TextHeight("000")
If dirSel = 0
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
a$ = zeros(numeroSalleDir)
DrawText(175,220,a$)
FrontColor(RGB(0,0,0))
a$ = zeros(dir(numeroSalleDir,0))
DrawText(175,260,a$)
If dirSel = 1
  FrontColor(RGB(255,255,255))
EndIf
DrawText(750,460,a$)
FrontColor(RGB(0,0,0))
a$ = zeros(dir(numeroSalleDir,1))
DrawText(175,280,a$)
If dirSel = 2
  FrontColor(RGB(255,255,255))
EndIf
DrawText(330,280,a$)
FrontColor(RGB(0,0,0))
a$ = zeros(dir(numeroSalleDir,2))
DrawText(175,300,a$)
If dirSel = 3
  FrontColor(RGB(255,255,255))
EndIf
DrawText(330,460,a$)
FrontColor(RGB(0,0,0))
a$ = zeros(dir(numeroSalleDir,3))
DrawText(175,320,a$)
If dirSel = 4
  FrontColor(RGB(255,255,255))
EndIf
DrawText(750,280,a$)
FrontColor(RGB(0,0,0))
a$ = zeros(dir(numeroSalleDir,4))
DrawText(175,340,a$)
If dirSel = 5
  FrontColor(RGB(255,255,255))
EndIf
DrawText(530,70,a$)
FrontColor(RGB(0,0,0))
a$ = zeros(dir(numeroSalleDir,5))
DrawText(175,360,a$)
If dirSel = 6
  FrontColor(RGB(255,255,255))
EndIf
DrawText(530,520,a$)
DrawingMode(#PB_2DDrawing_AlphaBlend)
DrawImage(ImageID(nseo),350,100)
DrawingMode(#PB_2DDrawing_Default)
boutonBlanc(360, 560, 80, 30)
centerText("MENU",400, 560 + 15,0,0,0)
zoneClick(0,0) = 1
zoneClick(0,1) = 360
zoneClick(0,2) = 560
zoneClick(0,3) = 80
zoneClick(0,4) = 30
StopDrawing()
EndProcedure

; Afficher le menu Texte Objets
Procedure menuTexteObj()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 80, 700, 30)
centerText("TEXTE OBJETS",60 + (TextWidth("TEXTE OBJETS") / 2),95,0,0,0)
Dim listeMenu.s(3)
listeMenu(0) = "MENU"
listeMenu(1) = "EFFA"
listeMenu(2) = "EDIT"
i = 0
For y = 0 To 2
	boutonBlanc(10, 265 + (35 * y), 80, 30)
	centerText(listeMenu(i),50, 265 + (35 * y) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 10
	zoneClick(i,2) = 265 + (35 * y)
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
centerText("OBJET",400, 230,0,0,0)
a$ = zeros(numeroObjet)
FrontColor(RGB(255,0,0))
Box(420 + TextWidth("OBJET"),230 - (TextHeight("OBJET")/2),TextWidth("000"),TextHeight("000"))
leftText(a$,420 + TextWidth("OBJET"),230 - (TextHeight("OBJET")/2),0,0,0)
boutonBlanc(100,265,690,100)
If kb
  cursor$ = "_"
EndIf
If Not multiLineText(objet(numeroObjet)+cursor$,100,265,690,100,20,20,0,0,0,#False)
	objet(numeroObjet) = Left(objet(numeroObjet),Len(objet(numeroObjet)) - 1)
EndIf
v$ = objet(numeroObjet)
multiLineText(objet(numeroObjet)+cursor$,100,265,690,100,20,20,0,0,0)
DrawingMode(#PB_2DDrawing_AlphaBlend)
DrawImage(ImageID(deco2),300,350)
DrawingMode(#PB_2DDrawing_Default)
StopDrawing()
EndProcedure

; Afficher le menu Placer Objets
Procedure menuPlacerObj()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("PLACER OBJETS",60 + (TextWidth("PLACER OBJETS") / 2),35,0,0,0)
boutonBlanc(360, 560, 80, 30)
centerText("MENU",400, 560 + 15,0,0,0)
zoneClick(0,0) = 1
zoneClick(0,1) = 360
zoneClick(0,2) = 560
zoneClick(0,3) = 80
zoneClick(0,4) = 30
centerText("OBJET",400, 130,0,0,0)
a$ = zeros(numeroObjetLieu)
FrontColor(RGB(255,0,0))
Box(420 + TextWidth("OBJET"),130 - (TextHeight("OBJET")/2),TextWidth("000"),TextHeight("000"))
zoneClick(1,0) = 2
zoneClick(1,1) = 420 + TextWidth("OBJET")
zoneClick(1,2) = 130 - (TextHeight("OBJET")/2)
zoneClick(1,3) = TextWidth("000")
zoneClick(1,4) = TextHeight("000")
If ObjLieuSel = 0
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(420 + TextWidth("OBJET"),130 - (TextHeight("OBJET")/2), a$)
boutonBlanc(55,165,690,100)
multiLineText(objet(numeroObjetLieu)+cursor$,55,165,690,100,20,20,0,0,0)
centerText("EN SALLE",400, 330,0,0,0)
a$ = zeros(objLieu(numeroObjetLieu))
FrontColor(RGB(255,0,0))
Box(420 + TextWidth("EN SALLE"),330 - (TextHeight("EN SALLE")/2),TextWidth("000"),TextHeight("000"))
zoneClick(2,0) = 3
zoneClick(2,1) = 420 + TextWidth("EN SALLE")
zoneClick(2,2) = 330 - (TextHeight("EN SALLE")/2)
zoneClick(2,3) = TextWidth("000")
zoneClick(2,4) = TextHeight("000")
If ObjLieuSel = 1
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(420 + TextWidth("EN SALLE"),330 - (TextHeight("EN SALLE")/2),a$)
boutonBlanc(55,365,690,100)
multiLineText(lieu(objLieu(numeroObjetLieu))+cursor$,55,365,690,100,20,20,0,0,0)
StopDrawing()
EndProcedure

; Afficher le menu Evts. Mineurs
Procedure menuEvtsMin()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("EVTS. MINEURS",60 + (TextWidth("EVTS. MINEURS") / 2),35,0,0,0)
Dim listeMenu.s(4)
listeMenu(0) = "MENU"
listeMenu(1) = "SUIV"
listeMenu(2) = "PREC"
listeMenu(3) = "INST"
i = 0
For y = 0 To 3
	boutonBlanc(10, 400 + (35 * (y + 1)), 80, 30)
	centerText(listeMenu(i),50, 400 + (35 * (y + 1)) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 10
	zoneClick(i,2) = 400 + (35 * (y + 1))
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
boutonBlanc(5, 100, 130, 80)
centerText("VERBE",70,110,255,0,0)
FrontColor(RGB(255,0,0))
Box(70 - (TextWidth("000")/2),130,TextWidth("000"),TextHeight("000"))
If EMinSel = 0
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(70 - (TextWidth("000")/2),130,zeros(EMinVerbe(numCondAct)))
centerText(verb(EMinVerbe(numCondAct),findVerb(EMinVerbe(numCondAct))),70,160,0,0,0)
zoneClick(4,0) = 5
zoneClick(4,1) = 70 - (TextWidth("000")/2)
zoneClick(4,2) = 130
zoneClick(4,3) = TextWidth("000")
zoneClick(4,4) = TextHeight("000")
boutonBlanc(5, 200, 130, 80)
centerText("OBJET 1",70,210,255,0,0)
FrontColor(RGB(255,0,0))
Box(70 - (TextWidth("000")/2),230,TextWidth("000"),TextHeight("000"))
If EMinSel = 1
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(70 - (TextWidth("000")/2),230,zeros(EMinObjet1(numCondAct)))
centerText(verb(EMinObjet1(numCondAct),findVerb(EMinObjet1(numCondAct))),70,260,0,0,0)
zoneClick(5,0) = 6
zoneClick(5,1) = 70 - (TextWidth("000")/2)
zoneClick(5,2) = 230
zoneClick(5,3) = TextWidth("000")
zoneClick(5,4) = TextHeight("000")
boutonBlanc(5, 300, 130, 80)
centerText("OBJET 2",70,310,255,0,0)
FrontColor(RGB(255,0,0))
Box(70 - (TextWidth("000")/2),330,TextWidth("000"),TextHeight("000"))
If EMinSel = 2
  FrontColor(RGB(255,255,255))
Else
  FrontColor(RGB(0,0,0))
EndIf
DrawText(70 - (TextWidth("000")/2),330,zeros(EMinObjet2(numCondAct)))
centerText(verb(EMinObjet2(numCondAct),findVerb(EMinObjet2(numCondAct))),70,360,0,0,0)
zoneClick(6,0) = 7
zoneClick(6,1) = 70 - (TextWidth("000")/2)
zoneClick(6,2) = 330
zoneClick(6,3) = TextWidth("000")
zoneClick(6,4) = TextHeight("000")
a$ = "Conditions"
maxi = 14
If EMinCondAct = EM_ACTIONS
	a$ = "Actions"
	maxi = 25
EndIf
FrontColor(RGB(255,0,0))
Box(270 - (TextWidth(a$)/2),60,TextWidth(a$),TextHeight(a$))
zoneClick(7,0) = 8
zoneClick(7,1) = 270 - (TextWidth(a$)/2)
zoneClick(7,2) = 60
zoneClick(7,3) = TextWidth(a$)
zoneClick(7,4) = TextHeight(a$)
centerText(a$,270,60+(TextHeight(a$)/2),255,255,255)
boutonBlanc(140, 80, 260, (maxi * 20) + 10)
i = 8
For y = 0 To maxi - 1
	If EMinCondAct = EM_CONDITIONS
		a$ = cond(y)
	Else
		a$ = act(y)
	EndIf
	bicolorText(a$,142,82 + (y * 20))
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 102
	zoneClick(i,2) = 82 + (y * 20)
	zoneClick(i,3) = 260
	zoneClick(i,4) = 20
	i + 1
Next
FrontColor(RGB(0,0,0))
LineXY(410,80,410+320,80)
LineXY(410+320,80,410+320,80+510)
LineXY(410+320,80+510,410,80+510)
LineXY(410,80+510,410,80)
gi = minZC2
For y = 0 To 24
	a$ = ""
	If EMinCondAct = EM_CONDITIONS
		If numCond(y,0,numCondAct) > -1
			a$ = cond(numCond(y,0,numCondAct))
			tind = bicolorTextLinks(a$,412,82 + (y * 20),numCond(y,1,numCondAct),numCond(y,2,numCondAct),numCond(y,3,numCondAct))
			If tind > 0
				indC1 = y
				indC2 = tind
				indC3 = numCondAct
			EndIf
			gi + 1
		EndIf
	Else
		If numAct(y,0,numCondAct) > -1
			a$ = act(numAct(y,0,numCondAct))
			tind = bicolorTextLinks(a$,412,82 + (y * 20),numAct(y,1,numCondAct),numAct(y,2,numCondAct),numAct(y,3,numCondAct))
			If tind > 0
				indA1 = y
				indA2 = tind
				indA3 = numCondAct
			EndIf
			gi + 1
		EndIf
	EndIf
Next
If EMinCondAct = EM_CONDITIONS And supprCond > -1
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  If EMinSel = 39
		DrawImage(ImageID(supprSel),720,80 + (supprCond * 20))
	Else
		DrawImage(ImageID(suppr),720,80 + (supprCond * 20))
	EndIf
  DrawingMode(#PB_2DDrawing_Default)
	zoneClick(39,0) = 40
	zoneClick(39,1) = 720
	zoneClick(39,2) = 80 + (supprCond * 20)
	zoneClick(39,3) = 80
	zoneClick(39,4) = 20
ElseIf EMinCondAct = EM_ACTIONS And supprAct > -1
  DrawingMode(#PB_2DDrawing_AlphaBlend)
	If EMinSel = 39
		DrawImage(ImageID(supprSel),720,80 + (supprAct * 20))
	Else
		DrawImage(ImageID(suppr),720,80 + (supprAct * 20))	
	EndIf
  DrawingMode(#PB_2DDrawing_Default)
	zoneClick(39,0) = 40
	zoneClick(39,1) = 720
	zoneClick(39,2) = 80 + (supprAct * 20)
	zoneClick(39,3) = 80
	zoneClick(39,4) = 20
EndIf
StopDrawing()
EndProcedure

; Afficher le menu Evts. Majeurs
Procedure menuEvtsMaj()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("EVTS. MAJEURS",60 + (TextWidth("EVTS. MAJEURS") / 2),35,0,0,0)
Dim listeMenu.s(4)
listeMenu(0) = "MENU"
listeMenu(1) = "SUIV"
listeMenu(2) = "PREC"
listeMenu(3) = "INST"
i = 0
For y = 0 To 3
	boutonBlanc(10, 400 + (35 * (y + 1)), 80, 30)
	centerText(listeMenu(i),50, 400 + (35 * (y + 1)) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 10
	zoneClick(i,2) = 400 + (35 * (y + 1))
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
a$ = "Conditions"
maxi = 14
If EMajCondAct = EM_ACTIONS
	a$ = "Actions"
	maxi = 25
EndIf
FrontColor(RGB(255,0,0))
Box(270 - (TextWidth(a$)/2),60,TextWidth(a$),TextHeight(a$))
zoneClick(4,0) = 5
zoneClick(4,1) = 270 - (TextWidth(a$)/2)
zoneClick(4,2) = 60
zoneClick(4,3) = TextWidth(a$)
zoneClick(4,4) = TextHeight(a$)
centerText(a$,270,60+(TextHeight(a$)/2),255,255,255)
boutonBlanc(140, 80, 260, (maxi * 20) + 10)
i = 5
For y = 0 To maxi - 1
	If EMajCondAct = EM_CONDITIONS
		a$ = cond(y)
	Else
		a$ = act(y)
	EndIf
	bicolorText(a$,142,82 + (y * 20))
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 102
	zoneClick(i,2) = 82 + (y * 20)
	zoneClick(i,3) = 260
	zoneClick(i,4) = 20
	i + 1
Next
FrontColor(RGB(0,0,0))
LineXY(410,80,410+320,80)
LineXY(410+320,80,410+320,80+510)
LineXY(410+320,80+510,410,80+510)
LineXY(410,80+510,410,80)
gi = minZC2
For y = 0 To 24
	a$ = ""
	If EMajCondAct = EM_CONDITIONS
		If numCondMaj(y,0,numCondActMaj) > -1
			a$ = cond(numCondMaj(y,0,numCondActMaj))
			tind = bicolorTextLinks(a$,412,82 + (y * 20),numCondMaj(y,1,numCondActMaj),numCondMaj(y,2,numCondActMaj),numCondMaj(y,3,numCondActMaj))
			If tind > 0
				indC1Maj = y
				indC2Maj = tind
				indC3Maj = numCondActMaj
			EndIf
			gi + 1
		EndIf
	Else
		If numActMaj(y,0,numCondActMaj) > -1
			a$ = act(numActMaj(y,0,numCondActMaj))
			tind = bicolorTextLinks(a$,412,82 + (y * 20),numActMaj(y,1,numCondActMaj),numActMaj(y,2,numCondActMaj),numActMaj(y,3,numCondActMaj))
			If tind > 0
				indA1Maj = y
				indA2Maj = tind
				indA3Maj = numCondActMaj
			EndIf
			gi + 1
		EndIf
	EndIf
Next	
If EMajCondAct = EM_CONDITIONS And supprCondMaj > -1
  DrawingMode(#PB_2DDrawing_AlphaBlend)
	If EMajSel = 39
		DrawImage(ImageID(supprSel),720,80 + (supprCondMaj * 20))
	Else
		DrawImage(ImageID(suppr),720,80 + (supprCondMaj * 20))
	EndIf
  DrawingMode(#PB_2DDrawing_Default)
	zoneClick(39,0) = 40
	zoneClick(39,1) = 720
	zoneClick(39,2) = 80 + (supprCondMaj * 20)
	zoneClick(39,3) = 80
	zoneClick(39,4) = 20
ElseIf EMajCondAct = EM_ACTIONS And supprActMaj > -1
  DrawingMode(#PB_2DDrawing_AlphaBlend)
	If EMajSel = 39
		DrawImage(ImageID(supprSel),720,80 + (supprActMaj * 20))
	Else
		DrawImage(ImageID(suppr),720,80 + (supprActMaj * 20))
	EndIf
  DrawingMode(#PB_2DDrawing_Default)
	zoneClick(39,0) = 40
	zoneClick(39,1) = 720
	zoneClick(39,2) = 80 + (supprActMaj * 20)
	zoneClick(39,3) = 80
	zoneClick(39,4) = 20
EndIf
StopDrawing()
EndProcedure

; Afficher le menu Mess. Systèmes
Procedure menuMsgSystemes()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 80, 700, 30)
centerText("MESS. SYSTEMES",60 + (TextWidth("MESS. SYSTEMES") / 2),95,0,0,0)
Dim listeMenu.s(3)
listeMenu(0) = "MENU"
listeMenu(1) = "EFFA"
listeMenu(2) = "EDIT"
i = 0
For y = 0 To 2
	boutonBlanc(10, 265 + (35 * y), 80, 30)
	centerText(listeMenu(i),50, 265 + (35 * y) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 10
	zoneClick(i,2) = 265 + (35 * y)
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
centerText("MESSAGE",400, 230,0,0,0)
a$ = zeros(numeroMsgSys)
FrontColor(RGB(255,0,0))
Box(420 + TextWidth("MESSAGE"),230 - (TextHeight("MESSAGE")/2),TextWidth("000"),TextHeight("000"))
leftText(a$,420 + TextWidth("MESSAGE"),230 - (TextHeight("MESSAGE")/2),0,0,0)
boutonBlanc(100,265,690,100)
If kb
  cursor$ = "_"
EndIf
If Not multiLineText(sys(numeroMsgSys)+cursor$,100,265,690,100,20,20,0,0,0,#False)
	sys(numeroMsgSys) = Left(sys(numeroMsgSys),Len(sys(numeroMsgSys)) - 1)
EndIf
v$ = sys(numeroMsgSys)
multiLineText(sys(numeroMsgSys)+cursor$,100,265,690,100,20,20,0,0,0)
DrawingMode(#PB_2DDrawing_AlphaBlend)
DrawImage(ImageID(deco1),137,435)
DrawingMode(#PB_2DDrawing_Default)
StopDrawing()
EndProcedure

; Afficher le menu Multimedia
Procedure menuMM()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 80, 700, 30)
centerText("MULTIMEDIA",60 + (TextWidth("MULTIMEDIA") / 2),95,0,0,0)
boutonBlanc(200,200,400,180)
jpeg = 0
ogg = 0
centerText("Présents dans le dossier projet :",400,220,0,0,0)
oldDirectory$ = AppDir$
SetCurrentDirectory(gameDir$)
If FileSize("introduction.jpg") > 0
  a$ = "Image d'introduction"
Else
  a$ = "Pas d'image d'introduction"
EndIf
centerText(a$,400,260,0,0,0)
If FileSize("introduction.ogg") > 0
  a$ = "Son d'introduction"
Else
  a$ = "Pas de son d'introduction"
EndIf
centerText(a$,400,280,0,0,0)
If FileSize("ecran.jpg") > 0
  a$ = "Image écran"
Else
  a$ = "Pas d'image écran"
EndIf
centerText(a$,400,300,0,0,0)
For i = 0 To 252
  If FileSize(Str(i)+".jpg") > 0
    jpeg + 1
  EndIf
Next
centerText(Str(jpeg)+" images d'illustration trouvées",400,320,0,0,0)
For i = 0 To 999
  If FileSize(Str(i)+".ogg") > 0
    ogg + 1
  EndIf
Next
centerText(Str(ogg)+" sons ogg trouvés",400,340,0,0,0)
boutonBlanc(360, 400, 80, 30)
centerText("MENU",400, 400 + 15,0,0,0)
zoneClick(0,0) = 1
zoneClick(0,1) = 360
zoneClick(0,2) = 400
zoneClick(0,3) = 80
zoneClick(0,4) = 30	
SetCurrentDirectory(oldDirectory$)
StopDrawing()
EndProcedure

; Afficher le menu Sauver Fichier
Procedure menuSauve()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("SAUVER FICHIER",60 + (TextWidth("SAUVER FICHIER") / 2),35,0,0,0)
boutonBlanc(10,100,780,220)
For i = 0 To 9
	centerText(tenDirs(i),400,120 + (i * 20),0,0,0)
Next
Dim listeMenu.s(3)
listeMenu(0) = "MENU"
listeMenu(1) = "EFFA"
listeMenu(2) = "EDIT"
i = 0
For y = 0 To 2
	boutonBlanc(10, 365 + (35 * y), 80, 30)
	centerText(listeMenu(i),50, 365 + (35 * y) + 15,0,0,0)
	zoneClick(i,0) = i + 1
	zoneClick(i,1) = 10
	zoneClick(i,2) = 365 + (35 * y)
	zoneClick(i,3) = 80
	zoneClick(i,4) = 30	
	i+1
Next
boutonBlanc(150,400,600,30)
If kb
  cursor$ = "_"
EndIf
If Not multiLineText(savedGame$+cursor$,150,400,600,30,20,5,0,0,0,#False)
	savedGame$ = Left(savedGame$,Len(savedGame$) - 1)
EndIf
v$ = savedGame$
multiLineText(savedGame$+cursor$,150,400,600,30,20,5,0,0,0)
boutonBlanc(300, 460, 200, 30)
centerText("SAUVER",400, 460 + 15,0,0,0)
zoneClick(3,0) = 4
zoneClick(3,1) = 300
zoneClick(3,2) = 460
zoneClick(3,3) = 200
zoneClick(3,4) = 30	
StopDrawing()
EndProcedure

; Afficher le menu Charger Fichier
Procedure menuCharge()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("CHARGER FICHIER",60 + (TextWidth("CHARGER FICHIER") / 2),35,0,0,0)
boutonBlanc(10,100,780,220)
For i = 0 To 9
	centerText(tenDirs(i),400,120 + (i * 20),0,0,0)
	zoneClick(i+1,0) = i+2
	zoneClick(i+1,1) = 10
	zoneClick(i+1,2) = 120 + (i * 20) - 10
	zoneClick(i+1,3) = 780
	zoneClick(i+1,4) = 20	
Next
boutonBlanc(100,400,600,30)
leftText(savedGame$,120,405,0,0,0)
boutonBlanc(360, 460, 80, 30)
centerText("MENU",400, 460 + 15,0,0,0)
zoneClick(0,0) = 1
zoneClick(0,1) = 360
zoneClick(0,2) = 460
zoneClick(0,3) = 80
zoneClick(0,4) = 30	
StopDrawing()
EndProcedure

; Afficher le menu Attrib. Objets
Procedure menuAttribObj()
clearZoneClick()
StartDrawing(ImageOutput(0))
Box(0,0,800,600,RGB(128,128,128))
boutonBlanc(50, 20, 700, 30)
centerText("ATTRIB. OBJETS",60 + (TextWidth("ATTRIB. OBJETS") / 2),35,0,0,0)
centerText("OBJET",350, 100,0,0,0)
a$ = zeros(numeroAttribObjet)
FrontColor(RGB(255,0,0))
Box(370 + TextWidth("OBJET"),100 - (TextHeight("OBJET")/2),TextWidth("000"),TextHeight("000"))
zoneClick(0,0) = 1
zoneClick(0,1) = 370 + TextWidth("OBJET")
zoneClick(0,2) = 100 - (TextHeight("OBJET")/2)
zoneClick(0,3) = TextWidth("000")
zoneClick(0,4) = TextHeight("000")
If attrSel = 0
  col = 255
Else
  col = 0
EndIf
leftText(a$,370 + TextWidth("OBJET"),100 - (TextHeight("OBJET")/2),col,col,col)
boutonBlanc(55,140,690,100)
If kb
  cursor$ = "_"
EndIf
If Not multiLineText(objet(numeroAttribObjet)+cursor$,55,140,690,100,20,20,0,0,0,#False)
	objet(numeroAttribObjet) = Left(objet(numeroAttribObjet),Len(objet(numeroAttribObjet)) - 1)
EndIf
v$ = objet(numeroAttribObjet)
multiLineText(objet(numeroAttribObjet)+cursor$,55,140,690,100,20,20,0,0,0)
leftText("Mot associé",80,260,0,0,0)
boutonBlanc(55,290,150,30)
a$ = zeros(attr(numeroAttribObjet,0))
FrontColor(RGB(255,0,0))
Box(60,296,TextWidth("000"),TextHeight("000"))
zoneClick(1,0) = 2
zoneClick(1,1) = 60
zoneClick(1,2) = 296
zoneClick(1,3) = TextWidth("000")
zoneClick(1,4) = TextHeight("000")
If attrSel = 1
  col = 255
Else
  col = 0
EndIf
leftText(a$,60,296,col,col,col)
a$ = verb(attr(numeroAttribObjet,0),findVerb(attr(numeroAttribObjet,0)))
If a$ = ""
  a$ = "Aucun"
EndIf
leftText(a$,62 + TextWidth("000"),296,0,0,0)
leftText("Spécifications",470,260,0,0,0)
leftText("Pr",460,296,0,0,0)
If attr(numeroAttribObjet,1) = #True
  a$ ="OUI"
Else
  a$ = "NON"
EndIf
FrontColor(RGB(255,0,0))
Box(462 + TextWidth("Pr "),296,TextWidth("NON"),TextHeight("NON"))
zoneClick(2,0) = 3
zoneClick(2,1) = 462 + TextWidth("Pr ")
zoneClick(2,2) = 296
zoneClick(2,3) = TextWidth("NON")
zoneClick(2,4) = TextHeight("NON")
If attrSel = 2
  col = 255
Else
  col = 0
EndIf
leftText(a$,462 + TextWidth("Pr "),296,col,col,col)
leftText("Ma",462 + TextWidth("Pr ") + 40 + TextWidth("NON"),296,0,0,0)
If attr(numeroAttribObjet,2) = #True
  a$ ="OUI"
Else
  a$ = "NON"
EndIf
FrontColor(RGB(255,0,0))
Box(462 + TextWidth("Pr ") + 40 + TextWidth("NON") + TextWidth("Ma "),296,TextWidth("NON"),TextHeight("NON"))
zoneClick(3,0) = 4
zoneClick(3,1) = 462 + TextWidth("Pr ") + 40 + TextWidth("NON") + TextWidth("Ma ")
zoneClick(3,2) = 296
zoneClick(3,3) = TextWidth("NON")
zoneClick(3,4) = TextHeight("NON")
If attrSel = 3
  col = 255
Else
  col = 0
EndIf
leftText(a$,462 + TextWidth("Pr ") + 40 + TextWidth("NON") + TextWidth("Ma "),296,col,col,col)
boutonBlanc(360, 500, 80, 30)
centerText("MENU", 400,515,0,0,0)
zoneClick(4,0) = 5
zoneClick(4,1) = 360
zoneClick(4,2) = 500
zoneClick(4,3) = 80
zoneClick(4,4) = 30
StopDrawing()
EndProcedure

; Tester les clicks sur les boutons
Procedure testClicks(mx,my)
	For i = 0 To MaxZC - 1
		If mx >= zoneClick(i,1) And mx < zoneClick(i,1) + zoneClick(i,3) And my >= zoneClick(i,2) And my < zoneClick(i,2) + zoneClick(i,4)
			ProcedureReturn zoneClick(i,0)
		EndIf
	Next
	ProcedureReturn 0
EndProcedure

; Trouver le verbe suivant (selection)
Procedure findNextSelVerb()
i = verbselx
j = verbsely
If verbselx = 255 And verbsely = 4
  ProcedureReturn #False
EndIf
found = #False
While found = #False
	verbsely + 1
	If verbsely = 10
		verbsely = 0
		verbselx + 1
		If verbselx = 256
			verbselx = i
			verbsely = j
			ProcedureReturn #False
		EndIf
	EndIf
	If verb(verbselx,verbsely) <> ""
	  ProcedureReturn #True
	EndIf
Wend
EndProcedure

; Trouver le verbe précédent (selection)
Procedure findBackSelVerb()
i = verbselx
j = verbsely
If verbselx = 0 And verbsely = 0
  ProcedureReturn #False
EndIf
found = #False
While found = #False
	verbsely - 1
	If verbsely = -1
		verbsely = 9
		verbselx - 1
		If verbselx = -1
			verbselx = i
			verbsely = j
			ProcedureReturn #False
		EndIf
	EndIf
	If verb(verbselx,verbsely) <> ""
	  ProcedureReturn #True
	EndIf
Wend
EndProcedure

; Trouver le verbe suivant (début de liste)
Procedure findNextVerb()
i = verbx
j = verby
If verbx = 255 And verby = 4
  ProcedureReturn #False
EndIf
found = #False
While found = #False
	verby + 1
	If verby = 10
		verby = 0
		verbx + 1
		If verbx = 256
			verbx = i
			verby = j
			ProcedureReturn #False
		EndIf
	EndIf
	If verb(verbx,verby) <> ""
		ProcedureReturn #True
	EndIf
Wend
EndProcedure

; Trouver le verbe précédent (début de liste)
Procedure findBackVerb()
i = verbx
j = verby
If verbx = 0 And verby = 0
  ProcedureReturn #False
EndIf
found = #False
While found = #False
	verby - 1
	If verby = -1
		verby = 9
		verbx - 1
		If verbx = -1
			verbx = i
			verby = j
			ProcedureReturn #False
		EndIf
	EndIf
	If verb(verbx,verby) <> ""
		ProcedureReturn #True
	EndIf
Wend
EndProcedure

; Retourne nombre chainé avec des zéros
Procedure.s zeros(n)
	c$ = Str(n)
	While Len(c$) < 3
		c$ = "0" + c$
	Wend
	ProcedureReturn c$
EndProcedure

; Trouve le premier verbe plein du numéro ou renvoie 0
Procedure findVerb(v1)
	For v2 = 0 To 9
	  If verb(v1,v2) <> ""
	    ProcedureReturn v2
	  EndIf
	Next
	ProcedureReturn 0
EndProcedure

; Affiche un texte en remplaçant '*' par 'n' en rouge
Procedure bicolorText(t$,x,y)
	While Len(t$) > 0
		If Left(t$,1) = "*"
			FrontColor(RGB(255,0,0))
			DrawText(x,y,"n")
			x + TextWidth("n")
		Else
			FrontColor(RGB(0,0,0))			
			DrawText(x,y,Left(t$,1))
			x + TextWidth(Left(t$,1))
		EndIf
		t$ = Mid(t$,2)
	Wend
EndProcedure


; Affiche un texte en remplaçant '*' par 'nnn' en rouge créant son lien
Procedure bicolorTextLinks(t$,x,y,n1,n2,n3)
	If menuType = menuEvtsMineurs
		e1 = EMinSel
		e2 = EMinCondAct
		z1 = zoneCond
		z2 = zoneAct
	Else
		e1 = EMajSel
		e2 = EMajCondAct
		z1 = zoneCondMaj
		z2 = zoneActMaj
	EndIf
	i = 0
	retval = 0
	Dim n(3)
	n(0) = n1
	n(1) = n2
	n(2) = n3
	While Len(t$) > 0
		If Left(t$,1) = "*"
			FrontColor(RGB(255,0,0))
		  a$ = zeros(n(i))
			Box(x,y,TextWidth(a$),TextHeight(a$))
			zoneClick(gi,0) = gi + 1
			zoneClick(gi,1) = x
			zoneClick(gi,2) = y
			zoneClick(gi,3) = TextWidth(a$)
			zoneClick(gi,4) = TextHeight(a$)
			If e1 > 1 And ((gi + 1 = z1 And e2 = EM_CONDITIONS) Or (gi + 1 = z2 And e2 = EM_ACTIONS))
				FrontColor(RGB(255,255,255))
				retval = i + 1
			Else
				FrontColor(RGB(0,0,0))
			EndIf
			DrawText(x,y,a$)
			x + TextWidth(a$)
			i + 1
			gi + 1
		Else
			FrontColor(RGB(0,0,0))
			DrawText(x,y,Left(t$,1))
			x + TextWidth(Left(t$,1))
		EndIf
		t$ = Mid(t$,2)
	Wend
	ProcedureReturn retval
EndProcedure

; Retourner une chaine d'un caractère unique sans caractere interdit
Procedure.s noForbidenChar(c$)
	Select c$
		Case "<",">",":",Chr(34),"/","\","|","?","*"
			ProcedureReturn ""
	EndSelect 
	ProcedureReturn c$
EndProcedure

; Sauver fichier .jad
Procedure saveJad(nom$,rep$)
If FileSize(AppDir$+rep$+nom$) > 0
	nbak$ = Left(nom$,Len(nom$) - 3) + "bak"
	If FileSize(AppDir$+rep$+nbak$) > 0
	  DeleteFile(AppDir$+rep$+nbak$)
	EndIf
	RenameFile(AppDir$+rep$+nom$,AppDir$+SL+rep$+nbak$)
EndIf
fic = CreateFile(#PB_Any, AppDir$+rep$+nom$)
If fic = 0
  error("Impossible de sauver le fichier "+nom$+" !")
EndIf
For i = 0 To 255
	For j = 0 To 9
		WriteStringN(fic,verb(i,j))
	Next
	WriteStringN(fic,msg(i))
	WriteStringN(fic,lieu(i))
	For j = 0 To 5
		WriteStringN(fic,Str(dir(i,j)))
	Next
	WriteStringN(fic,objet(i))
	WriteStringN(fic,Str(objLieu(i)))
	WriteStringN(fic,sys(i))
	For j = 0 To 2
		WriteStringN(fic,Str(attr(i,j)))
	Next
Next
WriteStringN(fic,Str(zoneImage\x))
WriteStringN(fic,Str(zoneImage\y))
WriteStringN(fic,Str(zoneImage\w))
WriteStringN(fic,Str(zoneImage\h))
WriteStringN(fic,Str(zoneDescription\x))
WriteStringN(fic,Str(zoneDescription\y))
WriteStringN(fic,Str(zoneDescription\w))
WriteStringN(fic,Str(zoneDescription\h))
WriteStringN(fic,Str(zoneTexte\x))
WriteStringN(fic,Str(zoneTexte\y))
WriteStringN(fic,Str(zoneTexte\w))
WriteStringN(fic,Str(zoneTexte\h))
WriteStringN(fic,Str(zoneInventaire\x))
WriteStringN(fic,Str(zoneInventaire\y))
WriteStringN(fic,Str(zoneInventaire\w))
WriteStringN(fic,Str(zoneInventaire\h))
WriteStringN(fic,Str(maxInv))
WriteStringN(fic,Str(maxMain))
WriteStringN(fic,Str(condActCount))
For k = 0 To condActCount - 1
	WriteStringN(fic,Str(EMinVerbe(k)))
	WriteStringN(fic,Str(EMinObjet1(k)))
	WriteStringN(fic,Str(EMinObjet2(k)))
Next
For i = 0 To 24
	For j = 0 To 3
		For k = 0 To condActCount - 1
			WriteStringN(fic,Str(numCond(i,j,k)))
			WriteStringN(fic,Str(numAct(i,j,k)))
		Next
	Next
Next
WriteStringN(fic,Str(condActCountMaj))
For i = 0 To 24
	For j = 0 To 3
		For k = 0 To condActCountMaj - 1
			WriteStringN(fic,Str(numCondMaj(i,j,k)))
			WriteStringN(fic,Str(numActMaj(i,j,k)))
		Next
	Next
Next
CloseFile(fic)
EndProcedure

; Effacer les zones clickables
Procedure clearZoneClick()
For i = 0 To maxZC - 1
	For j = 0 To 4
		zoneClick(i,j) = 0
	Next
Next
EndProcedure

; Affiche un texte en multiligne avec la couleur souhaitée
Procedure multiLineText(t$,x,y,w,h,margex,margey,r,g,b,draw = #True)
If t$ = ""
  ProcedureReturn #True
EndIf
DrawingMode(#PB_2DDrawing_Transparent)
FrontColor(RGB(r,g,b))
tvert = 0 ; taille verticale du texte
While Len(t$) > 0
	a$ = ""
	While TextWidth(a$) < (w - (margex * 2)) And t$ <> ""
		a$ = a$ + Left(t$,1)
		t$ = Mid(t$,2)
	Wend
	If a$ = ""
	  Break
	EndIf
	If TextWidth(a$) > (w - (margex * 2))
		t$ = Right(a$,1) + t$
		a$ = Left(a$,Len(a$)-1) 
	EndIf
	If Len(t$) > 0
		a2$ = a$
		t2$ = t$
		While Left(t$,1) <> " " And a$ <> ""
			t$ = Right(a$,1) + t$
			a$ = Left(a$,Len(a$)-1) 		
		Wend
		If a$ <> ""
			t$ = Mid(t$,2)
		Else
			t$ = t2$
			a$ = a2$
		EndIf
	EndIf
	tvert + TextHeight(a$)
	If tvert > (h - (margey * 2))
		ProcedureReturn #False
	Else
	  If draw
	    DrawText(x + margex,y + margey + tvert - TextHeight(a$), a$)
	  EndIf
	EndIf 
Wend
FrontColor(RGB(mr,mg,mb))
ProcedureReturn #True
EndProcedure

; Initialiser les données
Procedure initVars()
PrinSel = 0
condActCount = 1
numCondAct = 0
zoneCond = 0
zoneAct = 0
supprCond = -1
supprAct = -1
condActCountMaj = 1
numCondActMaj = 0
zoneCondMaj = 0
zoneActMaj = 0
supprCondMaj = -1
supprActMaj = -1
zoneImage\x = 0
zoneImage\y = 0
zoneImage\w = 400
zoneImage\h = 300
zoneDescription\x = 0
zoneDescription\y = 360
zoneDescription\w = 800
zoneDescription\h = 64
zoneTexte\x = 0
zoneTexte\y = 424
zoneTexte\w = 800
zoneTexte\h = 140
zoneInventaire\x = 490
zoneInventaire\y = 190
zoneInventaire\w = 300
zoneInventaire\h = 124
maxInv = 10
maxMain = 2
numeroMessage = 0
numeroSalle = 0
dirSel = 0
numeroSalleDir = 0
numeroObjet = 0
ObjLieuSel = 0
numeroObjetLieu = 0
EMinSel = 0
EMinCondAct = EM_CONDITIONS
EMajSel = 0
EMajCondAct = EM_CONDITIONS
numeroMsgSys = 0
baseDir = 0
dirCount = 10
For i = 0 To 9
	tenDirs(i) = ""
Next
updatedDirs(baseDir,dirCount)
gameDir$ = ""
savedGame$ = ""
numeroAttribObjet = 0
attrSel = 0
EndProcedure

; Afficher la page courante
Procedure drawPage()
Select menuType
	Case menuPrincipal
		menu()
	Case menuVocabulaire
		menuVoc()
	Case menuTexteMessages
		menuTexteMsg()
	Case menuTexteSalles
		menuTexteLieu()
	Case menuDeplacements
		menuDeplace()
	Case menuTexteObjets
		menuTexteObj()
	Case menuPlacerObjets
		menuPlacerObj()
	Case menuEvtsMineurs
		menuEvtsMin()
	Case menuEvtsMajeurs
		menuEvtsMaj()
	Case menuMessageSystemes
		menuMsgSystemes()
	Case menuMultimedia
		menuMM()
	Case menuSauverFichier
		menuSauve()
	Case menuChargerFichier
		menuCharge()
	Case menuAttribObjets
		menuAttribObj()
	Case menuTesterJeu
		oldDirectory$ = AppDir$
		If gameDir$ <> ""
			SetCurrentDirectory(gameDir$)
		Else
			SetCurrentDirectory("Projets")
			If FileSize("Sans Titre") = -2
				SetCurrentDirectory("Sans Titre")
			Else
				CreateDirectory("Sans Titre")
				SetCurrentDirectory("Sans Titre")
			EndIf
		EndIf
		menuTestGame()
		If gameDir$ = ""
		  DeleteFile("*.sav")
		EndIf
		SetCurrentDirectory(oldDirectory$)
		menuType = menuPrincipal
		menu()
EndSelect
EndProcedure
; IDE Options = PureBasic 5.41 LTS (Windows - x64)
; CursorPosition = 55
; FirstLine = 46
; Folding = ------
; EnableUnicode
; EnableXP
; Executable = Jadis.exe